Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Parameters.h	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Parameters.h	(revision 77)
@@ -0,0 +1,96 @@
+#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_network_read_unit_to_execution_unit_Parameters_h
+#define morpheo_behavioural_core_multi_execute_loop_execute_loop_network_read_unit_to_execution_unit_Parameters_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Common/include/Debug.h"
+#include "Behavioural/include/Parameters.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Types.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace read_unit_to_execution_unit {
+
+
+  class Parameters : public morpheo::behavioural::Parameters
+  {
+    //-----[ fields ]------------------------------------------------------------
+  public : const uint32_t    _nb_read_unit           ;
+  public : const uint32_t    _nb_execute_unit        ;
+  public : const uint32_t    _nb_context             ;
+  public : const uint32_t    _nb_front_end           ;
+  public : const uint32_t    _nb_ooo_engine          ;
+  public : const uint32_t    _nb_packet              ;
+  public : const uint32_t    _size_general_data      ;
+  public : const uint32_t    _size_special_data      ;
+  public : const uint32_t    _nb_general_register    ;
+  public : const uint32_t    _nb_special_register    ;
+  public : const uint32_t    _size_store_queue       ;
+  public : const uint32_t    _size_load_queue        ;
+  public : const Tpriority_t _priority               ;
+  public :       bool     ** _table_routing          ; //array [nb_read_unit][nb_execute_unit]
+  public :       bool     ** _table_execute_type     ; //array [nb_execute_unit][nb_type]
+  public :       bool     ** _table_execute_thread   ; //array [nb_execute_unit][nb_thread]
+
+  public : const uint32_t    _size_context_id        ;
+  public : const uint32_t    _size_front_end_id      ;
+  public : const uint32_t    _size_ooo_engine_id     ;
+  public : const uint32_t    _size_packet_id         ;
+  public : const uint32_t    _size_general_register  ;
+  public : const uint32_t    _size_special_register  ;
+
+  public : const bool        _have_port_context_id   ;
+  public : const bool        _have_port_front_end_id ;
+  public : const bool        _have_port_ooo_engine_id;
+  public : const bool        _have_port_packet_id    ;
+
+  public : const uint32_t    _nb_thread              ;
+  public :       uint32_t    _nb_load_store_unit     ;
+  public :       uint32_t    _nb_functionnal_unit    ;
+
+    //-----[ methods ]-----------------------------------------------------------
+  public : Parameters  (uint32_t    nb_read_unit           ,
+			uint32_t    nb_execute_unit        ,
+			uint32_t    nb_context             ,
+			uint32_t    nb_front_end           ,
+			uint32_t    nb_ooo_engine          ,
+			uint32_t    nb_packet              ,
+			uint32_t    size_general_data      ,
+			uint32_t    size_special_data      ,
+			uint32_t    nb_general_register    ,
+			uint32_t    nb_special_register    ,
+			uint32_t    size_store_queue       ,
+			uint32_t    size_load_queue        ,
+			Tpriority_t priority               ,
+			bool     ** table_routing          ,
+			bool     ** table_execute_type     ,
+			bool     ** table_execute_thread   );
+  public : Parameters  (Parameters & param) ;
+  public : ~Parameters () ;
+
+  public :        std::string   msg_error  (void);
+
+  public :        std::string   print      (uint32_t depth);
+  public : friend std::ostream& operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::core::multi_execute_loop::execute_loop::network::read_unit_to_execution_unit::Parameters & x);
+  };
+
+}; // end namespace read_unit_to_execution_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Read_unit_to_Execution_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Read_unit_to_Execution_unit.h	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Read_unit_to_Execution_unit.h	(revision 77)
@@ -0,0 +1,172 @@
+#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_network_read_unit_to_execution_unit_Read_unit_to_Execution_unit_h
+#define morpheo_behavioural_core_multi_execute_loop_execute_loop_network_read_unit_to_execution_unit_Read_unit_to_Execution_unit_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#include <iostream>
+#include <list>
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Types.h"
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Parameters.h"
+#ifdef STATISTICS
+#include "Behavioural/include/Stat.h"
+#endif
+#include "Behavioural/include/Component.h"
+#ifdef VHDL
+#include "Behavioural/include/Vhdl.h"
+#endif
+#include "Behavioural/include/Usage.h"
+
+namespace morpheo {
+namespace behavioural {
+
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace read_unit_to_execution_unit {
+
+
+  class Read_unit_to_Execution_unit 
+#if SYSTEMC
+    : public sc_module
+#endif
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Parameters
+  protected : const std::string  _name;
+  protected : const Parameters * _param;
+  private   : const Tusage_t     _usage;
+
+#ifdef STATISTICS
+  public    : Stat                           * _stat;
+#endif
+
+  public    : Component                      * _component;
+  private   : Interfaces                     * _interfaces;
+
+#ifdef SYSTEMC
+    // ~~~~~[ Interface ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // Interface
+  public    : SC_CLOCK                      *  in_CLOCK        ;
+  public    : SC_IN (Tcontrol_t)            *  in_NRESET       ;
+
+    // ~~~~~[ Interface "read_unit_out" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontrol_t        )   **  in_READ_UNIT_OUT_VAL                  ;
+  public    : SC_OUT(Tcontrol_t        )   ** out_READ_UNIT_OUT_ACK                  ;
+  public    : SC_IN (Tcontext_t        )   **  in_READ_UNIT_OUT_CONTEXT_ID           ;
+  public    : SC_IN (Tcontext_t        )   **  in_READ_UNIT_OUT_FRONT_END_ID         ;
+  public    : SC_IN (Tcontext_t        )   **  in_READ_UNIT_OUT_OOO_ENGINE_ID        ;
+  public    : SC_IN (Tpacket_t         )   **  in_READ_UNIT_OUT_PACKET_ID            ;
+  public    : SC_IN (Toperation_t      )   **  in_READ_UNIT_OUT_OPERATION            ;
+  public    : SC_IN (Ttype_t           )   **  in_READ_UNIT_OUT_TYPE                 ;
+  public    : SC_IN (Tlsq_ptr_t        )   **  in_READ_UNIT_OUT_STORE_QUEUE_PTR_WRITE;
+  public    : SC_IN (Tlsq_ptr_t        )   **  in_READ_UNIT_OUT_LOAD_QUEUE_PTR_WRITE ;
+  public    : SC_IN (Tcontrol_t        )   **  in_READ_UNIT_OUT_HAS_IMMEDIAT         ;
+  public    : SC_IN (Tgeneral_data_t   )   **  in_READ_UNIT_OUT_IMMEDIAT             ;
+  public    : SC_IN (Tgeneral_data_t   )   **  in_READ_UNIT_OUT_DATA_RA              ;
+  public    : SC_IN (Tgeneral_data_t   )   **  in_READ_UNIT_OUT_DATA_RB              ;
+  public    : SC_IN (Tspecial_data_t   )   **  in_READ_UNIT_OUT_DATA_RC              ;
+  public    : SC_IN (Tcontrol_t        )   **  in_READ_UNIT_OUT_WRITE_RD             ;
+  public    : SC_IN (Tgeneral_address_t)   **  in_READ_UNIT_OUT_NUM_REG_RD           ;
+  public    : SC_IN (Tcontrol_t        )   **  in_READ_UNIT_OUT_WRITE_RE             ;
+  public    : SC_IN (Tspecial_address_t)   **  in_READ_UNIT_OUT_NUM_REG_RE           ;
+
+    // ~~~~~[ Interface "execute_unit_in" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t        )   ** out_EXECUTE_UNIT_IN_VAL                  ;
+  public    : SC_IN (Tcontrol_t        )   **  in_EXECUTE_UNIT_IN_ACK                  ;
+  public    : SC_OUT(Tcontext_t        )   ** out_EXECUTE_UNIT_IN_CONTEXT_ID           ;
+  public    : SC_OUT(Tcontext_t        )   ** out_EXECUTE_UNIT_IN_FRONT_END_ID         ;
+  public    : SC_OUT(Tcontext_t        )   ** out_EXECUTE_UNIT_IN_OOO_ENGINE_ID        ;
+  public    : SC_OUT(Tpacket_t         )   ** out_EXECUTE_UNIT_IN_PACKET_ID            ;
+  public    : SC_OUT(Toperation_t      )   ** out_EXECUTE_UNIT_IN_OPERATION            ;
+  public    : SC_OUT(Ttype_t           )   ** out_EXECUTE_UNIT_IN_TYPE                 ;
+  public    : SC_OUT(Tlsq_ptr_t        )   ** out_EXECUTE_UNIT_IN_STORE_QUEUE_PTR_WRITE;
+  public    : SC_OUT(Tlsq_ptr_t        )   ** out_EXECUTE_UNIT_IN_LOAD_QUEUE_PTR_WRITE ;
+  public    : SC_OUT(Tcontrol_t        )   ** out_EXECUTE_UNIT_IN_HAS_IMMEDIAT         ;
+  public    : SC_OUT(Tgeneral_data_t   )   ** out_EXECUTE_UNIT_IN_IMMEDIAT             ;
+  public    : SC_OUT(Tgeneral_data_t   )   ** out_EXECUTE_UNIT_IN_DATA_RA              ;
+  public    : SC_OUT(Tgeneral_data_t   )   ** out_EXECUTE_UNIT_IN_DATA_RB              ;
+  public    : SC_OUT(Tspecial_data_t   )   ** out_EXECUTE_UNIT_IN_DATA_RC              ;
+  public    : SC_OUT(Tcontrol_t        )   ** out_EXECUTE_UNIT_IN_WRITE_RD             ;
+  public    : SC_OUT(Tgeneral_address_t)   ** out_EXECUTE_UNIT_IN_NUM_REG_RD           ;
+  public    : SC_OUT(Tcontrol_t        )   ** out_EXECUTE_UNIT_IN_WRITE_RE             ;
+  public    : SC_OUT(Tspecial_address_t)   ** out_EXECUTE_UNIT_IN_NUM_REG_RE           ;
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  private   : std::list<uint32_t> *** _destination; // [nb_read_unit][nb_thread][nb_type];
+#endif
+
+    // -----[ Methods ]---------------------------------------------------
+
+#ifdef SYSTEMC
+    SC_HAS_PROCESS (Read_unit_to_Execution_unit);
+#endif
+  public  :          Read_unit_to_Execution_unit              
+  (
+#ifdef SYSTEMC
+   sc_module_name                                name,
+#else					       
+   std::string                                   name,
+#endif					       
+#ifdef STATISTICS
+   morpheo::behavioural::Parameters_Statistics * param_statistics,
+#endif
+   Parameters                                  * param,
+   morpheo::behavioural::Tusage_t                usage=USE_ALL
+   );
+  public  :          ~Read_unit_to_Execution_unit             (void);
+					       
+  private : void        allocation                (
+#ifdef STATISTICS
+						   morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+						   void
+#endif
+						   );
+  private : void        deallocation              (void);
+					       
+#ifdef SYSTEMC				       
+  public  : void        transition                (void);
+  public  : void        genMealy                  (void);
+#endif					       
+
+#if VHDL				       
+  public  : void        vhdl                      (void);
+  private : void        vhdl_declaration          (Vhdl * & vhdl);
+  private : void        vhdl_body                 (Vhdl * & vhdl);
+#endif					       
+
+#ifdef STATISTICS
+  public  : void        statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
+#endif
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void        end_cycle                 (void);
+#endif
+  };
+
+}; // end namespace read_unit_to_execution_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Types.h	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Types.h	(revision 77)
@@ -0,0 +1,61 @@
+#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_network_read_unit_to_execution_unit_Types_h
+#define morpheo_behavioural_core_multi_execute_loop_execute_loop_network_read_unit_to_execution_unit_Types_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+#include "Common/include/ToString.h"
+#include "Common/include/FromString.h"
+#include "Common/include/ErrorMorpheo.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace read_unit_to_execution_unit {
+
+  typedef enum
+    {
+      PRIORITY_STATIC,
+      PRIORITY_ROUND_ROBIN
+    } Tpriority_t;
+
+}; // end namespace read_unit_to_execution_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+}; // end namespace behavioural
+
+  template<> inline std::string toString<morpheo::behavioural::core::multi_execute_loop::execute_loop::network::read_unit_to_execution_unit::Tpriority_t>(const morpheo::behavioural::core::multi_execute_loop::execute_loop::network::read_unit_to_execution_unit::Tpriority_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::core::multi_execute_loop::execute_loop::network::read_unit_to_execution_unit::PRIORITY_STATIC      : return "priority_static"; break;
+      case morpheo::behavioural::core::multi_execute_loop::execute_loop::network::read_unit_to_execution_unit::PRIORITY_ROUND_ROBIN : return "priority_round_robin"; break;
+      default    : return ""      ; break;
+      }
+  };
+
+  template<> inline morpheo::behavioural::core::multi_execute_loop::execute_loop::network::read_unit_to_execution_unit::Tpriority_t fromString<morpheo::behavioural::core::multi_execute_loop::execute_loop::network::read_unit_to_execution_unit::Tpriority_t>(const std::string& x)
+  {
+    if ( (x.compare("0")                    == 0) or
+         (x.compare("priority_static")      == 0))
+      return morpheo::behavioural::core::multi_execute_loop::execute_loop::network::read_unit_to_execution_unit::PRIORITY_STATIC;
+    if ( (x.compare("1")                    == 0) or
+         (x.compare("priority_round_robin") == 0))
+      return morpheo::behavioural::core::multi_execute_loop::execute_loop::network::read_unit_to_execution_unit::PRIORITY_ROUND_ROBIN;
+    throw (ERRORMORPHEO ("fromString","Unknow string : \""+x+"\""));
+  };
+
+
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Parameters.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Parameters.cpp	(revision 77)
@@ -0,0 +1,143 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Parameters.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace read_unit_to_execution_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Read_unit_to_Execution_unit::Parameters"
+  Parameters::Parameters (uint32_t    nb_read_unit           ,
+			  uint32_t    nb_execute_unit        ,
+			  uint32_t    nb_context             ,
+			  uint32_t    nb_front_end           ,
+			  uint32_t    nb_ooo_engine          ,
+			  uint32_t    nb_packet              ,
+			  uint32_t    size_general_data      ,
+			  uint32_t    size_special_data      ,
+			  uint32_t    nb_general_register    ,
+			  uint32_t    nb_special_register    ,
+			  uint32_t    size_store_queue       ,
+			  uint32_t    size_load_queue        ,
+			  Tpriority_t priority               ,
+			  bool     ** table_routing          ,
+			  bool     ** table_execute_type     ,
+			  bool     ** table_execute_thread   ):
+    _nb_read_unit            (nb_read_unit       ),
+    _nb_execute_unit         (nb_execute_unit    ),
+    _nb_context              (nb_context         ),
+    _nb_front_end            (nb_front_end       ),
+    _nb_ooo_engine           (nb_ooo_engine      ),
+    _nb_packet               (nb_packet          ),
+    _size_general_data       (size_general_data  ),
+    _size_special_data       (size_special_data  ),
+    _nb_general_register     (nb_general_register),
+    _nb_special_register     (nb_special_register),
+    _size_store_queue        (size_store_queue   ),
+    _size_load_queue         (size_load_queue    ),
+    _priority                (priority           ),
+
+    _size_context_id         (log2(nb_context         )),
+    _size_front_end_id       (log2(nb_front_end       )),
+    _size_ooo_engine_id      (log2(nb_ooo_engine      )),
+    _size_packet_id          (log2(nb_packet          )),
+    _size_general_register   (log2(nb_general_register)),
+    _size_special_register   (log2(nb_special_register)),
+    
+    _have_port_context_id    (_size_context_id    > 0),
+    _have_port_front_end_id  (_size_front_end_id  > 0),
+    _have_port_ooo_engine_id (_size_ooo_engine_id > 0),
+    _have_port_packet_id     (_size_packet_id     > 0),
+
+    _nb_thread               (get_nb_thread (nb_context, nb_front_end, nb_ooo_engine))
+  {
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"Begin");
+
+    _table_routing        = table_routing       ;
+    _table_execute_type   = table_execute_type  ;
+    _table_execute_thread = table_execute_thread;
+    
+    _nb_load_store_unit = 0;
+
+    for (uint32_t i=0; i<nb_execute_unit; i++)
+      if (table_execute_type[i][TYPE_MEMORY] == true)
+	_nb_load_store_unit ++;
+
+    // a execution_unit can't be a load_store unit and a functionnal unit
+    _nb_functionnal_unit = nb_execute_unit-_nb_load_store_unit;
+
+    test();
+
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"End");
+  };
+  
+#undef  FUNCTION
+#define FUNCTION "Read_unit_to_Execution_unit::Parameters (copy)"
+  Parameters::Parameters (Parameters & param):
+    _nb_read_unit            (param._nb_read_unit           ),
+    _nb_execute_unit         (param._nb_execute_unit        ),
+    _nb_context              (param._nb_context             ),
+    _nb_front_end            (param._nb_front_end           ),
+    _nb_ooo_engine           (param._nb_ooo_engine          ),
+    _nb_packet               (param._nb_packet              ),
+    _size_general_data       (param._size_general_data      ),
+    _size_special_data       (param._size_special_data      ),
+    _nb_general_register     (param._nb_general_register    ),
+    _nb_special_register     (param._nb_special_register    ),
+    _size_store_queue        (param._size_store_queue       ),
+    _size_load_queue         (param._size_load_queue        ),
+    _priority                (param._priority               ),
+
+    _size_context_id         (param._size_context_id        ),
+    _size_front_end_id       (param._size_front_end_id      ),
+    _size_ooo_engine_id      (param._size_ooo_engine_id     ),
+    _size_packet_id          (param._size_packet_id         ),
+    _size_general_register   (param._size_general_register  ),
+    _size_special_register   (param._size_special_register  ),
+
+    _have_port_context_id    (param._have_port_context_id   ),
+    _have_port_front_end_id  (param._have_port_front_end_id ),
+    _have_port_ooo_engine_id (param._have_port_ooo_engine_id),
+    _have_port_packet_id     (param._have_port_packet_id    ),
+
+    _nb_thread               (param._nb_thread              )
+  {
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"Begin");
+
+    _table_routing        = param._table_routing       ;
+    _table_execute_type   = param._table_execute_type  ;
+    _table_execute_thread = param._table_execute_thread;
+    _nb_load_store_unit   = param._nb_load_store_unit  ;
+    _nb_functionnal_unit  = param._nb_functionnal_unit ;
+
+    test();
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"End");
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Read_unit_to_Execution_unit::~Parameters"
+  Parameters::~Parameters () 
+  {
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"Begin");
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"End");
+  };
+
+}; // end namespace read_unit_to_execution_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Parameters_msg_error.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Parameters_msg_error.cpp	(revision 77)
@@ -0,0 +1,137 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Parameters.h"
+#include <sstream>
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace read_unit_to_execution_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Read_unit_to_Execution_unit::msg_error"
+  std::string Parameters::msg_error(void)
+  {
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"Begin");
+
+    std::string msg = "";
+
+    // TYPE         | multiple? | Optionnal? | Exclusive? | Comment
+    //--------------+-----------+------------+------------+---------
+    // TYPE_ALU     |     X     |            |            |
+    // TYPE_SHIFT   |     X     |            |            | ror is optionnal
+    // TYPE_MOVE    |     X     |            |            | cmov is optionnal
+    // TYPE_TEST    |     X     |            |            |
+    // TYPE_MUL_DIV |     X     |            |            | div is optionnal
+    // TYPE_EXTEND  |     X     |     X      |            |
+    // TYPE_FIND    |     X     |     X      |            |
+    // TYPE_SPECIAL |           |            |            | mac unit is optionnal
+    // TYPE_CUSTOM  |           |     X      |            |
+    // TYPE_BRANCH  |     X     |            |            |
+    // TYPE_MEMORY  |           |            |     X      |
+    
+    bool type_valid     [_nb_type];
+    bool type_uniq      [_nb_type]; // one thread can have multiple destination for this type ?
+    bool type_optionnal [_nb_type]; // this type is optionnal ?
+    bool type_exclusive [_nb_type]; // a unit that implement this type must be implement an another type ?
+
+    for (Ttype_t i=0; i<_nb_type; i++)
+      {
+	type_valid     [i] = false;
+	type_uniq      [i] = false;
+	type_optionnal [i] = false;
+	type_exclusive [i] = false;
+      }
+
+    type_valid     [TYPE_ALU    ] = true;
+    type_valid     [TYPE_SHIFT  ] = true;
+    type_valid     [TYPE_MOVE   ] = true;
+    type_valid     [TYPE_TEST   ] = true;
+    type_valid     [TYPE_MUL_DIV] = true;
+    type_valid     [TYPE_EXTEND ] = true;
+    type_valid     [TYPE_FIND   ] = true;
+    type_valid     [TYPE_SPECIAL] = true;
+    type_valid     [TYPE_CUSTOM ] = true;
+    type_valid     [TYPE_BRANCH ] = true;
+    type_valid     [TYPE_MEMORY ] = true;
+
+    type_uniq      [TYPE_SPECIAL] = true;
+    type_uniq      [TYPE_CUSTOM ] = true;
+    type_uniq      [TYPE_MEMORY ] = true;
+
+    type_optionnal [TYPE_EXTEND ] = true;
+    type_optionnal [TYPE_FIND   ] = true;
+    type_optionnal [TYPE_CUSTOM ] = true;
+
+    type_exclusive [TYPE_MEMORY ] = true;
+
+    bool type_present [_nb_thread][_nb_type];
+    for (uint32_t i=0; i<_nb_thread; i++)
+      for (Ttype_t j=0; j<_nb_type; j++)
+	type_present [i][j] = false;
+    
+    for (uint32_t i=0; i<_nb_execute_unit; i++)
+      for (uint32_t j=0; j<_nb_thread; j++)
+	if (_table_execute_thread [i][j] == true)
+	  // this execute_unit execute this thread !
+	  for (Ttype_t k=0; k<=_nb_type; k++)
+	    if (_table_execute_type[i][k] == true)
+	      {
+		// Test uniq type
+		if (type_present [j][k] and type_uniq[k])
+		  msg += "  - The execute_unit '"+toString(i)+"' can execute operation of type '"+toString_type(k)+"' at the thread '"+toString(j)+"'. But an another execute_unit can be execute the same type for the same thread. And the type must be uniq !.\n";
+		
+		type_present [j][k] = true;
+	      }
+
+    for (Ttype_t j=0; j<_nb_type; j++)
+      if (type_valid [j] and not type_optionnal[j])
+	for (uint32_t i=0; i<_nb_thread; i++)
+	  if (not type_present [i][j])
+	    msg += "  - The thread '"+toString(i)+"' can't access at the execute_unit to execute the type's operation '"+toString_type(j)+"' (and this type is not optionnal !).\n";
+	    
+    // Test all excluve type
+    for (uint32_t i=0; i<_nb_execute_unit; i++)
+      for (Ttype_t j=0; j<=_nb_type; j++)
+	if (type_exclusive [j] and _table_execute_type[i][j])
+	  for (Ttype_t k=0; k<=_nb_type; k++)
+	    if ((j != k) and (_table_execute_type[i][k] == true))
+	      {
+		msg += "  - The execute_unit ["+toString(i)+"] implement the type '"+toString_type(j)+"', and this type is exclusive with all others type.\n";
+		break;
+	      }
+
+    for (uint32_t i=0; i<_nb_execute_unit; i++)
+      {
+	uint32_t j;
+	for (j=0; j<_nb_thread; j++)
+	  if (_table_execute_thread [i][j] == true)
+	    break;
+
+	if (j == _nb_thread)
+	  msg += "  - The execute_unit ["+toString(i)+"] have none source's thread.\n";
+      }	  
+    
+    return msg;
+
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"End");
+  };
+
+}; // end namespace read_unit_to_execution_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Parameters_print.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Parameters_print.cpp	(revision 77)
@@ -0,0 +1,70 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/include/Parameters.h"
+#include "Behavioural/include/XML.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace read_unit_to_execution_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Read_unit_to_Execution_unit::print"
+  std::string Parameters::print (uint32_t depth)
+  {
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"Begin");
+
+    XML xml ("read_unit_to_execution_unit");
+
+    xml.balise_open("read_unit_to_execution_unit");
+    xml.singleton_begin("nb_read_unit       "); xml.attribut("value",toString(_nb_read_unit       )); xml.singleton_end();
+    xml.singleton_begin("nb_execute_unit    "); xml.attribut("value",toString(_nb_execute_unit    )); xml.singleton_end();
+    xml.singleton_begin("nb_context         "); xml.attribut("value",toString(_nb_context         )); xml.singleton_end();
+    xml.singleton_begin("nb_front_end       "); xml.attribut("value",toString(_nb_front_end       )); xml.singleton_end();
+    xml.singleton_begin("nb_ooo_engine      "); xml.attribut("value",toString(_nb_ooo_engine      )); xml.singleton_end();
+    xml.singleton_begin("nb_packet          "); xml.attribut("value",toString(_nb_packet          )); xml.singleton_end();
+    xml.singleton_begin("size_general_data  "); xml.attribut("value",toString(_size_general_data  )); xml.singleton_end();
+    xml.singleton_begin("size_special_data  "); xml.attribut("value",toString(_size_special_data  )); xml.singleton_end();
+    xml.singleton_begin("nb_general_register"); xml.attribut("value",toString(_nb_general_register)); xml.singleton_end();
+    xml.singleton_begin("nb_special_register"); xml.attribut("value",toString(_nb_special_register)); xml.singleton_end();
+    xml.singleton_begin("size_store_queue   "); xml.attribut("value",toString(_size_store_queue   )); xml.singleton_end();
+    xml.singleton_begin("size_load_queue    "); xml.attribut("value",toString(_size_load_queue    )); xml.singleton_end();
+    xml.singleton_begin("priority           "); xml.attribut("value",toString(_priority           )); xml.singleton_end();
+    xml.balise_close();
+
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"End");
+    
+    return xml.get_body(depth);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Read_unit_to_Execution_unit::operator<<"
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::core::multi_execute_loop::execute_loop::network::read_unit_to_execution_unit::Parameters & x)
+  {
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"Begin");
+
+    output_stream << x.print(0);
+    
+    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"End");
+
+    return output_stream;
+  };
+
+}; // end namespace read_unit_to_execution_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
